local pCommand = gkinterface.GKProcessCommand
local floor = math.floor
local shipName = ""


--------------------------
-- capship commands section
--------------------------

-- check name of active capship
function Capship_tab.T.Tab.checkCapship()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    if Capship_tab.T.Tab.ship.controlTrident == true then
        shipName = Capship_tab.T.Tab.ship.tridentName
        return shipName
    elseif Capship_tab.T.Tab.ship.controlGoliath == true then 
        shipName = Capship_tab.T.Tab.ship.goliathName
        return shipName
    else
        print("\12750b8cfNo Capship specified. Please setup the Capship Tab with /mdicapship \127o")
    end
end

-- follow
function Capship_tab.T.Tab.capFollow()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "follow"
    SendChat(msg, "PRIVATE", shipName)
end

-- follow target
function Capship_tab.T.Tab.capFollowTarget()
    shipName = Capship_tab.T.Tab.checkCapship()
    local targetName, _, _, _, _, _ = GetTargetInfo()
    if targetName ~= nil then 
        local msg = "follow " .. targetName
        if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
            print("\12750b8cfAsteroid too slow. The pilot is at risk of falling asleep while following, please target a player.\127o")
        elseif targetName:match("cu%)") then
            print("\12750b8cfCargo crates can\'t fly. Please target a player to follow.\127o")
        else
            SendChat(msg, "PRIVATE", shipName)
        end
    end
end

-- park
function Capship_tab.T.Tab.capPark()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "park";
	SendChat(msg, "PRIVATE", shipName)
end

-- turbo
function Capship_tab.T.Tab.capTurbo()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "turbo"
	SendChat(msg, "PRIVATE", shipName) 
end

-- shields
function Capship_tab.T.Tab.capShields()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "shield"
	SendChat(msg, "PRIVATE", shipName)
end

-- attack
function Capship_tab.T.Tab.capAttack()
    shipName = Capship_tab.T.Tab.checkCapship()
    local targetName, _, _, _, _, _ = GetTargetInfo()
    if targetName ~= nil then
        local msg = "attack " .. targetName
        if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
            print("\12750b8cfAsteroids don't make good targets. Find something more challenging to shoot and please target a player.\127o")
        elseif targetName:match("cu%)") then
            print("\12750b8cfCargo crates make lame opponents. Please target a capship to attack.\127o")
        else
            SendChat(msg, "PRIVATE", shipName)
        end
    end
end

-- defend
function Capship_tab.T.Tab.capDefend()
    shipName = Capship_tab.T.Tab.checkCapship()
    local targetName, _, _, _, _, _ = GetTargetInfo()
    if targetName ~= nil then 
        local msg = "defend " .. targetName
        if targetName:match("Asteroid") or targetName:match("Ice Crystal") then
            print("\12750b8cfCapship unwilling to sacrifice itself to save an asteroid, please target a player.\127o")
        elseif targetName:match("cu%)") then
            print("\12750b8cfJust scoop the cargo, there is no need to defend it. Please target a player to defend.\127o")
        else
            SendChat(msg, "PRIVATE", shipName)
        end
    end
end

-- patrol
function Capship_tab.T.Tab.capPatrol()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "patrol"
	SendChat(msg, "PRIVATE", shipName)
end

-- cease fire
function Capship_tab.T.Tab.capCeaseFire()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "cease fire"
	SendChat(msg, "PRIVATE", shipName)
end

-- prepare for docking
function Capship_tab.T.Tab.capPrepareDocking()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "prepare for docking"
	SendChat(msg, "PRIVATE", shipName)
end

-- mine
function Capship_tab.T.Tab.capMine()
    shipName = Capship_tab.T.Tab.checkCapship()
    local msg = "mine"
	SendChat(msg, "PRIVATE", shipName)
end

-- gather
function Capship_tab.T.Tab.capGather()
    shipName = Capship_tab.T.Tab.checkCapship()
    local targetOre = GetTargetInfo()
    if targetOre ~= nil then
        if targetOre:match("Premium") then
            local split, rest = string.match(targetOre, "(.*)Ore(.*)")
            local searchOre = string.sub(split, 9)
            local msg = "gather " .. searchOre;
            SendChat(msg, "PRIVATE", shipName)
        else
            local split, rest = string.match(targetOre, "(.*)Ore(.*)")
            local searchOre = split
            local msg = "gather " .. searchOre;
            SendChat(msg, "PRIVATE", shipName)
        end
    end
end




--------------------------
-- feature tab
--------------------------


-- autocontrol docking
function Capship_tab.T.Tab.autocontrolCapship()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    if Capship_tab.T.Tab.ship.autocontrolCapship == false then
        Capship_tab.T.Tab.ship.autocontrolCapship = true
        print("\12750b8cfAutocontrol for capship is ON.\127o")
    else
        Capship_tab.T.Tab.ship.autocontrolCapship = false
        print("\12750b8cfAutocontrol for Capship is OFF.\127o")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end


-- switch controlled capship
function Capship_tab.T.Tab.switchCapship()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));

    local goliathName = Capship_tab.T.Tab.ship.goliathName or "None"
    local tridentName = Capship_tab.T.Tab.ship.tridentName or "None"

    if (Capship_tab.T.Tab.ship.controlTrident == true) and (goliathName ~= " " or "None") then
        Capship_tab.T.Tab.ship.controlTrident = false
        Capship_tab.T.Tab.ship.controlGoliath = true
        print("\12750b8cfCapship Control now set to: " .. goliathName .. "\127o")
        
    elseif (Capship_tab.T.Tab.ship.controlTrident == true) and (goliathName == " " or "None") then
        Capship_tab.T.Tab.ship.controlTrident = true
        Capship_tab.T.Tab.ship.controlGoliath = false
        print("\12750b8cfNo Goliath assigned. Capship Control now set to: " .. tridentName .. "\127o")
        
    elseif (Capship_tab.T.Tab.ship.controlTrident == false) and (tridentName ~= " " or "None") then
        Capship_tab.T.Tab.ship.controlTrident = true
        Capship_tab.T.Tab.ship.controlGoliath = false
        print("\12750b8cfCapship Control now set to: " .. tridentName .. "\127o")
        
    elseif (Capship_tab.T.Tab.ship.controlTrident == false) and (tridentName == " " or "None") then
        Capship_tab.T.Tab.ship.controlTrident = false
        Capship_tab.T.Tab.ship.controlGoliath = true
        print("\12750b8cfNo Trident assigned. Capship Control now set to: " .. goliathName .. "\127o")
        
    else
        print("\12750b8cfError! Capship not assigned.\127o")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end


-- give user key to target
function Capship_tab.T.Tab.giveKey()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local targetName = GetTargetInfo()
    if targetName ~= nil then 
        local keyID = "None"
        if Capship_tab.T.Tab.ship.controlTrident == true then
            keyID = Capship_tab.T.Tab.ship.tridentKey
        elseif Capship_tab.T.Tab.ship.controlGoliath == true then 
            keyID = Capship_tab.T.Tab.ship.goliathKey
        end
        if keyID == "None" or nil then
            print("\12750b8cfNo capship key assigned. Please use /mdicapship\127o")
        else
            Keychain.giveuserkey(targetName, keyID)
            print("\12750b8cfCapship key given to: " .. targetName .. "\127o")
        end
    else 
        print("\12750b8cfNo target specified.\127o")
    end
end



-- revoke user key from target
function Capship_tab.T.Tab.revokeKey()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local targetName = GetTargetInfo()
    local keyID = "None"
    if targetName ~= nil then
        if Capship_tab.T.Tab.ship.controlTrident == true then
            keyID = Capship_tab.T.Tab.ship.tridentKey
        elseif Capship_tab.T.Tab.ship.controlGoliath == true then 
            keyID = Capship_tab.T.Tab.ship.goliathKey
        end
        if keyID == "None" or nil then
            print("\12750b8cfNo capship key assigned. Please use /mdicapship\127o")
        else
            Keychain.revokekey(targetName, keyID)
            print("\12750b8cfCapship key revoked for: " .. targetName .. "\127o")
        end
    else
        print("\12750b8cfNo target specified.\127o")
    end
end



-- plot to capship
function Capship_tab.T.Tab.findCapship()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local stationID = " "
    local sectorID = " "
    local capLocation = " "
    local currentCapship = " "
    if Capship_tab.T.Tab.ship.controlTrident == true then
        currentCapship = "Trident Type M"
    elseif Capship_tab.T.Tab.ship.controlGoliath == true then
        currentCapship = "Goliath"
    else
        print("\12750b8cfError! No capship to control assigned.\127o")
    end
    
    for itemID, _ in PlayerInventoryPairs() do
        local _, shipName, _, _, shipType, _, _, containerID, _, _ = GetInventoryItemInfo(itemID)
        if shipType:match(currentCapship) and containerID > 0 then -- found a capship!
            stationID = GetInventoryItemLocation(itemID)
            sectorID = GetSectorIDOfStation(stationID)
            capLocation = AbbrLocationStr(sectorID)
            print("Found: " .. currentCapship)
        end
    end
    NavRoute.SetFinalDestination(sectorID)
    print("\12750b8cfNavroute set to: " .. capLocation .. "\127o")
end


-- kick all gunners
function Capship_tab.T.Tab.kickGunners()
    local numberOfTurrets = GetNumStationTurrets()
    local turretID = 1
    local turretInfo = {}
    local ownCharID = GetCharacterID()
    if numberOfTurrets == 0 or nil then
        print("\12750b8cfYour ship has no Turrets!\127o")
    else
        while turretID <= numberOfTurrets do
            local turretInfo = GetStationTurretInfo(turretID)
            local gunnerCharID = turretInfo.controller
            if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
                Gunner.Kick(GetPlayerName(gunnerCharID))
            end
            turretID = turretID + 1
        end
        print("\12750b8cfAll gunners ejected from the ship.\127o")
    end
end



-- dismiss all gunners
function Capship_tab.T.Tab.dismissGunners()
    local numberOfTurrets = GetNumStationTurrets()
    local turretID = 1
    local turretInfo = {}
    local gunnerCharID = 0
    local ownCharID = GetCharacterID()
    if numberOfTurrets == 0 then
        print("\12750b8cfYour ship has no Turrets!\127o")
    else
        while turretID <= numberOfTurrets do
            turretInfo = GetStationTurretInfo(turretID)
            gunnerCharID = turretInfo.controller
            if (gunnerCharID ~= ownCharID) and (gunnerCharID ~= nil) then
                Gunner.Dismiss(GetPlayerName(gunnerCharID))
            end
            turretID = turretID + 1
        end
        print("\12750b8cfAll gunners dismissed from their turrets.\127o")
    end
end



-- take control of capship if enter_station event is triggered and autocontrol is true
function Capship_tab.T.Tab.autoControl(event, data)
	Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
	local stationType = GetStationType()
	if Capship_tab.T.Tab.ship.autocontrolCapship == true and stationType ~= nil then
		ControlOwnCapship()
	end
end



--------------------------
-- Turret options tab
--------------------------

-- enable/disable turret 1
function Capship_tab.T.Tab.enableTurret1()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabled1
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabled1 = true
        pCommand("disableturret 1")
    else
        Capship_tab.T.Tab.ship.turretDisabled1 = false
        pCommand("enableturret 1")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end

-- enable/disable turret 2
function Capship_tab.T.Tab.enableTurret2()
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabled2
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabled2 = true
        pCommand("disableturret 2")
    else
        Capship_tab.T.Tab.ship.turretDisabled2 = false
        pCommand("enableturret 2")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end

-- enable/disable turret 3
function Capship_tab.T.Tab.enableTurret3()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabled3
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabled3 = true
        pCommand("disableturret 3")
    else
        Capship_tab.T.Tab.ship.turretDisabled3 = false
        pCommand("enableturret 3")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end

-- enable/disable turret 4
function Capship_tab.T.Tab.enableTurret4()
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabled4
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabled4 = true
        pCommand("disableturret 4")
    else
        Capship_tab.T.Tab.ship.turretDisabled4 = false
        pCommand("enableturret 4")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end

-- enable/disable MISSILE turrets
function Capship_tab.T.Tab.enableTurretMISSILE()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabledMISSILE
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabledMISSILE = true
        pCommand("disableturret missiles")
    else
        Capship_tab.T.Tab.ship.turretDisabledMISSILE = false
        pCommand("enableturret missiles")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end

-- enable/disable ALL turrets
function Capship_tab.T.Tab.enableTurretALL()
    Capship_tab.T.Tab.ship = unspickle(LoadSystemNotes(Capship_tab.T.Tab.systemnotes));
    local turretStatus = Capship_tab.T.Tab.ship.turretDisabledALL
    if turretStatus == false then
        Capship_tab.T.Tab.ship.turretDisabledALL = true
        pCommand("disableturret all")
    else
        Capship_tab.T.Tab.ship.turretDisabledALL = false
        pCommand("enableturret all")
    end
    SaveSystemNotes(spickle(Capship_tab.T.Tab.ship), Capship_tab.T.Tab.systemnotes)
end



function Capship_tab.T.Tab.enterTurret1()
    pCommand("enterturret 1")
end

function Capship_tab.T.Tab.enterTurret2()
    pCommand("enterturret 2")
end

function Capship_tab.T.Tab.enterTurret3()
    pCommand("enterturret 3")
end

function Capship_tab.T.Tab.enterTurret4()
    pCommand("enterturret 4")
end


--------------------------
-- ships tab
--------------------------


-- undock ship 1
function Capship_tab.T.Tab.undockShip1()
    local shipList = GetShipList()
    if shipList[1] ~= nil then
    print("\12750b8cfShip #1 found. Undocking...\127o") 
    RequestLaunch(GetShipList()[1])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end

-- undock ship 2
function Capship_tab.T.Tab.undockShip2()
    local shipList = GetShipList()
    if shipList[2] ~= nil then
        print("\12750b8cfShip #2 found. Undocking...\127o") 
        RequestLaunch(GetShipList()[2])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end

-- undock ship 3
function Capship_tab.T.Tab.undockShip3()
    local shipList = GetShipList()
    if shipList[3] ~= nil then
        print("\12750b8cfShip #3 found. Undocking...\127o") 
        RequestLaunch(GetShipList()[3])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end

-- undock ship 4
function Capship_tab.T.Tab.undockShip4()
    local shipList = GetShipList()
    if shipList[4] ~= nil then
        print("\12750b8cfShip #4 found. Undocking...\127o") 
        RequestLaunch(GetShipList()[4])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end

-- undock ship 5
function Capship_tab.T.Tab.undockShip5()
    local shipList = GetShipList()
    if shipList[5] ~= nil then
        print("\12750b8cfShip #5 found. Undocking...\127o") 
        RequestLaunch(GetShipList()[5])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end

-- undock ship 6
function Capship_tab.T.Tab.undockShip6()
    local shipList = GetShipList()
    if shipList[6] ~= nil then
        print("\12750b8cfShip #6 found. Undocking...\127o") 
        RequestLaunch(GetShipList()[6])
    else
        print("\12750b8cfThe requested Ship is not here. Did you misplace it?\127o")
    end
end


